# Add project specific ProGuard rules here.
# By default, the flags in this file are appended to flags specified
# in /Users/mengcuiguang/Documents/softwareDevelopment/android-sdk-macosx/tools/proguard/proguard-android.txt
# You can edit the include path and order by changing the proguardFiles
# directive in build.gradle.
#
# For more details, see
#   http://developer.android.com/guide/developing/tools/proguard.html

# Add any project specific keep options here:

# If your project uses WebView with JS, uncomment the following
# and specify the fully qualified class name to the JavaScript interface
# class:
#-keepclassmembers class fqcn.of.javascript.interface.for.webview {
#   public *;
#}

    #指定代码的压缩级别
    -optimizationpasses 5

    #包明不混合大小写
    -dontusemixedcaseclassnames

    #不去忽略非公共的库类
    -dontskipnonpubliclibraryclasses

     #优化  不优化输入的类文件
    -dontoptimize

     #预校验
    -dontpreverify

     #混淆时是否记录日志
    -verbose

     # 混淆时所采用的算法
    -optimizations !code/simplification/arithmetic,!field/*,!class/merging/*

    #保护注解
    -keepattributes *Annotation*

    #保护内部类 保护反射
    -keepattributes Exceptions, Signature, InnerClasses ,EnclosingMethod

    # 保持哪些类不被混淆
    -keep public class * extends android.app.Fragment
    -keep public class * extends android.app.Activity
    -keep public class * extends android.app.Application
    -keep public class * extends android.app.Service
    -keep public class * extends android.data.BroadcastReceiver
    -keep public class * extends android.data.ContentProvider
    -keep public class * extends android.app.backup.BackupAgentHelper
    -keep public class * extends android.preference.Preference
    -keep public class com.android.vending.licensing.ILicensingService
    #如果有引用v4包可以添加下面这行
    -keep public class * extends android.support.v4.app.Fragment

    #忽略警告
    -ignorewarnings

    ##记录生成的日志数据,gradle build时在本项目根目录输出##

    #apk 包内所有 class 的内部结构
    -dump class_files.txt
    #未混淆的类和成员
    -printseeds seeds.txt
    #列出从 apk 中删除的代码
    -printusage unused.txt
    #混淆前后的映射
    -printmapping mapping.txt

    ########记录生成的日志数据，gradle build时 在本项目根目录输出-end######

    # ===================== 混淆保护自己项目的部分代码以及引用的第三方jar包library ================

    #okhttp
    -dontwarn com.squareup.okhttp.**
    -keep class com.squareup.okhttp.** { *;}
    -dontwarn okio.**

    #butterknife
    -keep class butterknife.** { *; }
    -dontwarn butterknife.internal.**
    -keep class **$$ViewBinder { *; }

    -keepclasseswithmembernames class * {
        @butterknife.* <fields>;
    }

    -keepclasseswithmembernames class * {
        @butterknife.* <methods>;
    }

    #忽略警告
    -dontwarn retrofit.**
    #保留一个完整的包
    -keep class retrofit.** {
        *;
    }


    #忽略警告
    -dontwarn rx.internal.util.unsafe.**
    #保留一个完整的包
    -keep class rx.internal.util.unsafe.** {
        *;
    }

    #忽略警告
    -dontwarn uk.co.senab.photoview.**
    #保留一个完整的包
    -keep class uk.co.senab.photoview.** {
          *;
    }


    #忽略警告
    -dontwarn rx.internal.util.unsafe.**
    #保留一个完整的包
    -keep class rx.internal.util.unsafe.** {
        *;
     }


    #忽略警告
    -dontwarn com.mints.goodmoney.mvp.model.**
    #保留实体类
    -keep class com.mints.goodmoney.mvp.model.** {
        *;
    }

    #忽略警告
    -dontwarn com.mints.goodmoney.ui.widgets.**
    #保留实体类
    -keep class com.mints.goodmoney.ui.widgets.** {
        *;
    }

    #系统的design 忽略警告
    -dontwarn android.support.design.widget.**
    #保留实体类
    -keep class android.support.design.widget.** {
        *;
    }

    #系统的renderscript 忽略警告
    -dontwarn android.support.v8.renderscript.**
    #保留实体类
    -keep class android.support.v8.renderscript.** {
         *;
     }


    #忽略警告
    -dontwarn cn.com.library.rxbus.**
    #保留实体类
    -keep class cn.com.library.rxbus.** {*;}

    #忽略警告  /高德
    -dontwarn com.amap.api.**
    -dontwarn com.autonavi.aps.amapapi.model.**
    -dontwarn com.loc.**
    #保留一个完整的包
    -keep class com.amap.api.** {*;}
    -keep class com.autonavi.aps.amapapi.model.** {*;}
    -keep class com.loc.** {*;}

    #忽略警告
    -dontwarn cn.fraudmetrix.sdk.**
    #保留一个完整的包
    -keep class cn.fraudmetrix.sdk.** {
         *;
    }

    #忽略警告
    -dontwarn com.nineoldandroids.**
    #保留一个完整的包
    -keep class com.nineoldandroids.** {
         *;
    }

    #忽略警告
    -dontwarn Decoder.**
    #保留一个完整的包
    -keep class Decoder.** {
         *;
    }

    #忽略警告
    -dontwarn com.nostra13.universalimageloader.**
    #保留实体类
    -keep class com.nostra13.universalimageloader.** {
         *;
    }

    #忽略警告
    -dontwarn com.megvii.**
    #保留实体类
    -keep class com.megvii.** { *; }

    -dontwarn cn.jpush.**
    -keep class cn.jpush.** { *; }

    #如果引用了v4或者v7包
    -dontwarn android.support.**


    #如果用用到Gson解析包的，直接添加下面这几行就能成功混淆，不然会报错。
    #gson
    -keepattributes Signature
    # Gson specific classes
    -keep class sun.misc.Unsafe { *; }
    # Application classes that will be serialized/deserialized over Gson
    -keep class com.google.gson.examples.android.model.** { *; }

# ===================== 混淆保护自己项目的部分代码以及引用的第三方jar包library-end ================

    -keep public class * extends android.view.View {
        public <init>(android.data.Context);
        public <init>(android.data.Context, android.util.AttributeSet);
        public <init>(android.data.Context, android.util.AttributeSet, int);
        public void set*(...);
    }

    #保持 native 方法不被混淆
    -keepclasseswithmembernames class * {
        native <methods>;
    }

    #保持自定义控件类不被混淆
    -keepclasseswithmembers class * {
        public <init>(android.data.Context, android.util.AttributeSet);
    }

    #保持自定义控件类不被混淆
    -keepclassmembers class * extends android.app.Activity {
       public void *(android.view.View);
    }

    #保持 Parcelable 不被混淆
    -keep class * implements android.os.Parcelable {
      public static final android.os.Parcelable$Creator *;
    }

    #保持 Serializable 不被混淆
    -keepnames class * implements java.io.Serializable

    #保持 Serializable 不被混淆并且enum 类也不被混淆
    -keepclassmembers class * implements java.io.Serializable {
        static final long serialVersionUID;
        private static final java.io.ObjectStreamField[] serialPersistentFields;
        !static !transient <fields>;
        !private <fields>;
        !private <methods>;
        private void writeObject(java.io.ObjectOutputStream);
        private void readObject(java.io.ObjectInputStream);
        java.lang.Object writeReplace();
        java.lang.Object readResolve();
    }

    #保持枚举 enum 类不被混淆 如果混淆报错，建议直接使用上面的 -keepclassmembers class * implements java.io.Serializable即可
    -keepclassmembers enum * {
      public static **[] values();
      public static ** valueOf(java.lang.String);
    }

    -keepclassmembers class * {
        public void *ButtonClicked(android.view.View);
    }

    #不混淆资源类
    -keepclassmembers class **.R$* {
        public static <fields>;
    }

    # 避免影响升级功能，需要keep住support包的类
    -keep class android.support.**{*;}



    # ===================== shareSDK START ================
    -dontwarn com.mob.**
    -dontwarn cn.sharesdk.**
    -dontwarn **.R$*

    -keep class cn.sharesdk.**{*;}
    -keep class com.sina.**{*;}
    -keep class **.R$* {*;}
    -keep class **.R{*;}

    -keep class com.mob.**{*;}
    # ======================= shareSDK END ===============




    # ===================== umeng START ================
    -keep class com.umeng.** {*;}
    -keepclassmembers class * {
       public <init> (org.json.JSONObject);
    }
    -keepclassmembers enum * {
        public static **[] values();
        public static ** valueOf(java.lang.String);
    }
    -keep public class com.mints.goodmoney.R$*{
    public static final int *;
    }
    # ======================= umeng END ================



    # ===================== 穿山甲 START ================
    -keep class com.bytedance.sdk.openadsdk.** { *; }
    -keep public interface com.bytedance.sdk.openadsdk.downloadnew.** {*;}
    -keep class com.pgl.sys.ces.* {*;}
    # ======================= 穿山甲 END ================



    # ===================== TalkingData START ================
    -dontwarn com.tendcloud.tenddata.**
    -keep class com.tendcloud.** {*;}
    -keep public class com.tendcloud.tenddata.** { public protected *;}
    -keepclassmembers class com.tendcloud.tenddata.**{
     public void *(***);
     }
    -keep class com.talkingdata.sdk.TalkingDataSDK {public *;}
    -keep class com.apptalkingdata.** {*;}
    -keep class dice.** {*; }
    -dontwarn dice.**
    # ======================= TalkingData END ================




    # ===================== 极光推送 START ================
        -keep class * extends cn.jpush.android.helpers.JPushMessageReceiver { *; }

        # ===================== 极光一键登录 ================
        -dontoptimize
        -dontpreverify
        -dontwarn cn.jpush.**
        -keep class cn.jpush.** { *; }
        -dontwarn cn.jiguang.**
        -keep class cn.jiguang.** { *; }
        -dontwarn com.cmic.**
        -keep class com.cmic.** { *; }
        -dontwarn com.unicom.**
        -keep class com.unicom.** { *; }
        -dontwarn cn.com.chinatelecom.**
        -keep class cn.com.chinatelecom.** { *; }
    # ======================= 极光推送 END ================



    # ===================== 数美 START ================
    -keep class com.ishumei.** { *; }
    # ======================= 数美 END ================


    # ===================== 猎豹游戏 START ================
    -keep class com.cmgame.x5fit.** {*;}
    -keep class com.cmgame.gdtfit.** {*;}
    -keep class com.cmcm.cmgame.** {*;}
    # ======================= 猎豹游戏 END ================




    # ===================== 移动安全联盟 START ================
    -keep class com.bun.miitmdid.core.** {*;}
    # ======================= 移动安全联盟 END ================




    # ===================== 一览视频 START ================
    -keep class com.yilan.sdk.**{
        *;
    }
    -dontwarn sun.misc.Unsafe
    -dontwarn org.conscrypt.*
    ###阿里云混淆
    -keep class com.alibaba.sdk.android.**{*;}
    -keep class com.ut.**{*;}
    -keep class com.ta.**{*;}
    # ======================= 一览视频 END ================





    # ===================== 推啊AD START ================
    -dontwarn com.lechuan.midunovel.**
    -keep class com.lechuan.midunovel.** { *; }
    # ======================= 推啊AD END ================



    # ===================== 掌阅书城 START ================
    -keep class com.zhangyue.**{*;}
    -keep class com.ireader.ireadersdk.IreaderApi {*;}
    -dontwarn com.alibaba.fastjson.**
    -keep class com.alibaba.fastjson.** { *; }
    -keep public class * extends androidx.fragment.app.Fragment
    -keep class androidx.core.app.NotificationCompat**{
        public *;
    }
    -dontwarn androidx.**
    -keep class androidx.** { *;}
    -keep public class * extends androidx.**
    -keep public class * extends androidx.fragment.app.FragmentContainer

    -keep class com.squareup.okhttp.** { *;}
    -keep class okhttp3.** { *; }
    -keep interface okhttp3.** { *; }
    -keep class okio.**{ *; }
    -keep interface okio.**{ *; }
    -dontwarn com.squareup.okhttp.**
    -dontwarn okio.**
    -dontwarn okhttp3.**
    
    -keep class com.qq.e.** {
        public protected *;
    }
    # ======================= 掌阅书城 END ================





    # ===================== 变现猫 START ================
    -keep class com.ss.android.* {*;}
    -keep class com.pgl.* {*;}

    -keep class com.qq.e.** {
     public protected *;
    }

    -keep class com.bxm.sdk.ad.**{ *;}
    -keep class com.bianxianmao.sdk.**{*;}

    -keep class android.support.v4.app.NotificationCompat**{
     public *;
    }
    # ======================= 变现猫 END ================